<template>
  <div class="transactions" v-loading="loading">
    <div class="transactions__title">
      <slot name="title" />
    </div>
    <Transaction
      v-for="(transaction, key) in transactions"
      :key="key"
      :transaction="transaction"
    />
  </div>
</template>

<script lang="ts">
import { defineComponent, computed, reactive } from '@nuxtjs/composition-api'
import Transaction from '@/components/profile/wallet/Transaction.vue'
import { Transactions_Bool_Exp } from '~/sdk/types'
import { useTransactionsSubscription } from '~/sdk/hooks'
import { AppEvents } from '~/types'

export default defineComponent<{
  where: Transactions_Bool_Exp
}>({
  name: 'Transactions',
  components: {
    Transaction
  },
  props: ['where'],
  setup({ where }, { root }) {
    const options = reactive({
      enabled: !!root.$accessor.connection.connectedAsUser
    })
    const { result, loading } = useTransactionsSubscription(
      {
        where,
        offset: 0
      },
      options
    )

    root.$on(
      AppEvents.ConnectedAsUser,
      (value: boolean) => (options.enabled = value)
    )

    const transactions = computed(() => result.value?.transactions || [])
    return { transactions, loading }
  }
})
</script>

<style lang="scss" scoped>
.transactions {
  &__title {
    font-weight: 500;
    font-size: 30px;
    line-height: 33px;
    letter-spacing: 0px;
    color: #ffffff;
    margin-bottom: 40px;
  }
}
</style>
